﻿using GrapeCity.Documents.Imaging;
using GrapeCity.Documents.Svg;
using System.Drawing;

namespace CreateSvgFromScratch
{
    public class GcSvgLogo
    {
        public void CreateSvgLogo()
        {
            //Configure the Canvas
            var svgDoc = new GcSvgDocument();
            svgDoc.RootSvg.Width = new SvgLength(250, SvgLengthUnits.Pixels);
            svgDoc.RootSvg.Height = new SvgLength(150, SvgLengthUnits.Pixels);

            //Add svg elements constituting the parts of the logo                                       


            //Configure Path builder to draw the left and right side logo handles
            var pb = new SvgPathBuilder();

            pb.AddMoveTo(false, 8, 121);
            pb.AddLineTo(false, 297, 25);
            pb.AddLineTo(false, 314, 68);
            pb.AddLineTo(false, 23, 164);
            pb.AddLineTo(false, 8, 121);
            pb.AddClosePath();

            var handles = new SvgPathElement()
            {
                PathData = pb.ToPathData(),
                Fill = new SvgPaint(Color.FromArgb(81, 59, 116)),
            };

            //Drawing the Circular part of the logo

            //Outer circle using Ellipse element
            var outerCircle = new SvgEllipseElement()
            {
                CenterX = new SvgLength(160, SvgLengthUnits.Pixels),
                CenterY = new SvgLength(92, SvgLengthUnits.Pixels),
                RadiusX = new SvgLength(90, SvgLengthUnits.Pixels),
                RadiusY = new SvgLength(80, SvgLengthUnits.Pixels),
                Fill = new SvgPaint(Color.FromArgb(81, 59, 116)),
                Stroke = new SvgPaint(Color.FromArgb(81, 59, 116))
            };

            //Inner cirlce using Circle Element
            var innerCircle = new SvgCircleElement()
            {
                CenterX = new SvgLength(160, SvgLengthUnits.Pixels),
                CenterY = new SvgLength(92, SvgLengthUnits.Pixels),
                Radius = new SvgLength(45, SvgLengthUnits.Pixels),
                Fill = new SvgPaint(Color.White),
                Stroke = new SvgPaint(Color.FromArgb(81, 59, 116))
            };

            //Add elements to SVG DOM
            svgDoc.RootSvg.Children.Insert(0, handles);
            svgDoc.RootSvg.Children.Insert(1, outerCircle);
            svgDoc.RootSvg.Children.Insert(2, innerCircle);
            
            
            //Configure viewbox to scale and fit the image within the viewport bounds
            
            SvgViewBox view = new SvgViewBox();
            view.MinX = 0;
            view.MinY = 0;
            view.Width = 320;
            view.Height = 175;
            svgDoc.RootSvg.ViewBox = view;
            

            //Save the content to an SVG file
            svgDoc.Save("Logo_250x150.svg");

        }
    }
}
